/*
 * Copyright 1994, 1995 Vectaport Inc., Cartoactive Systems
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */


/*
 * MapProjection -- base class for map projection mechanism
 */

#ifndef mapprojection_h
#define mapprojection_h

#include <OS/enter-scope.h>

class MapProjection {
public:
    MapProjection();
    virtual ~MapProjection();

    virtual void project(int& x, int& y) const = 0;
    virtual void project(int& x, int& y, int& z) const = 0;
    virtual void project(float& x, float& y) const = 0;
    virtual void project(float& x, float& y, float& z) const = 0;
    virtual void project(double& x, double& y) const = 0;
    virtual void project(double& x, double& y, double& z) const = 0;

    virtual void project(int* x, int* y, int npts) const = 0;
    virtual void project(int* x, int* y, int* z, int npts) const = 0;
    virtual void project(float* x, float* y, int npts) const = 0;
    virtual void project(float* x, float* y, float* z, int npts) const = 0;
    virtual void project(double* x, double* y, int npts) const = 0;
    virtual void project(double* x, double* y, double* z, int npts) const = 0;

    static int utmzone(float lon);

};

#endif
