/*
 * Copyright 1994, 1995 Vectaport Inc.
 * Copyright 1990, 1991 Stanford University
 *
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the names of the copyright holders not be used in
 * advertising or publicity pertaining to distribution of the software
 * without specific, written prior permission.  The copyright holders make
 * no representations about the suitability of this software for any purpose.
 * It is provided "as is" without express or implied warranty.
 *
 * THE COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES WITH REGARD TO THIS
 * SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDERS BE LIABLE FOR ANY SPECIAL,
 * INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
 * FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
 * WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 * 
 */

/*
 * MapExportCmd - a command for exporting map features to *draw
 */

#ifndef map_export_h
#define map_export_h

#include <OverlayUnidraw/ovexport.h>

class GraphicView;
class OverlaySelection;

enum ExportScriptType { IdrawType, OvIdrawType, MapIdrawType, DlgIdrawType, VpfIdrawType };

class MapExportCmd : public OvExportCmd {
public:
    MapExportCmd(ControlInfo*, ExportChooser* = nil);
    MapExportCmd(Editor* = nil, ExportChooser* = nil);
    virtual ~MapExportCmd();

    ExportScriptType type();

    virtual Command* Copy();
    virtual ClassId GetClassId();
    virtual boolean IsA(ClassId);

    virtual boolean Export(const char*);
    virtual boolean Selected(GraphicView*);
    void AddParentsToSelection();
protected:
    OverlaySelection* _s;
};

#endif
